searchNodes=[{"doc":"Plug that checks if your users are authorised to access the resource. You can use it at the router or controller level: # lib/my_app_web/controllers/post_controller.ex defmodule MyApp.PostController do plug Dictator def show(conn, params) do # ... end end # lib/my_app_web/router.ex defmodule MyAppWeb.Router do pipeline :authorised do plug Dictator end end Requires Phoenix (or at least conn.private[:phoenix_action] to be set). To load resources from the database, requires Ecto. See Dictator.Policies.EctoSchema. Dictator assumes your policies are in lib/my_app_web/policies/ and follow the MyAppWeb.Policies.Name naming convention. As an example, for posts, MyAppWeb.Policies.Post would be defined in lib/my_app_web/policies/post.ex. It is also assumed the current user is loaded and available on conn.assigns. By default, it is assumed to be under conn.assigns[:current_user], although this option can be overriden. Plug Options Options that you can pass to the module, when plugging it (e.g. plug Dictator, only: [:create, :update]). None of the following options are required. only: limits the actions to perform authorisation on to the provided list. except: limits the actions to perform authorisation on to exclude the provided list. policy: policy to apply. See above to understand how policies are inferred. key: key under which the current user is placed in conn.assigns or the session. Defaults to :current_user. fetch_strategy: Strategy to be used to get the current user. Can be either Dictator.FetchStrategies.Assigns to fetch it from conn.assigns or Dictator.FetchStrategies.Session to fetch it from the session. You can also implement your own strategy and pass it in this option or set it in the config. Defaults to Dictator.FetchStrategies.Assigns. Configuration options Options that you can place in your config/*.exs files. key: Same as the :key parameter in the plug option section. The plug option takes precedence, meaning you can place it in a config and then override it in specific controllers or pipelines. unauthorized_handler: Handler to be called when the user is not authorised to access the resource. Defaults to Dictator.UnauthorizedHandlers.Default.","ref":"Dictator.html","title":"Dictator","type":"module"},{"doc":"Helpers to get the dictator configs. Intended for internal use only.","ref":"Dictator.Config.html","title":"Dictator.Config","type":"module"},{"doc":"","ref":"Dictator.Config.html#get/2","title":"Dictator.Config.get/2","type":"function"},{"doc":"","ref":"Dictator.FetchStrategies.Assigns.html","title":"Dictator.FetchStrategies.Assigns","type":"module"},{"doc":"","ref":"Dictator.FetchStrategies.Session.html","title":"Dictator.FetchStrategies.Session","type":"module"},{"doc":"","ref":"Dictator.FetchStrategy.html","title":"Dictator.FetchStrategy","type":"behaviour"},{"doc":"","ref":"Dictator.FetchStrategy.html#c:fetch/2","title":"Dictator.FetchStrategy.fetch/2","type":"callback"},{"doc":"Policy definition commonly used in typical belongs_to associations. This policy assumes the users can read (:show, :index, :new, :create) any information but only write (:edit, :update, :delete) their own. As an example, in a typical Twitter-like application, a user has_many posts and a post belongs_to a user. You can define a policy to let users manage their own posts but read all others by doing the following: defmodule MyAppWeb.Policies.Post do alias MyApp.{Post, User} use Dictator.Policies.EctoSchema, for: Post def can?(_, action, _) when action in [:index, :show, :new, :create], do: true def can?(%User{id: id}, action, %{resource: %Post{user_id: id}}) when action in [:edit, :update, :delete], do: true def can?(_, _, _), do: false end This scenario is so common, it is abstracted completely through this module and you can simply use Dictator.Policies.BelongsTo, for: Post to make use of it. The following example is equivalent to the previous one: defmodule MyAppWeb.Policies.Post do use Dictator.Policies.BelongsTo, for: MyApp.Post end Allowed Options All options available in Dictator.Policies.EctoSchema plus the following: foreign_key: foreign key of the current user in the resource being accessed. If a Post belongs to a User, this option would typically be :user_id. Defaults to :user_id. owner_key: primary key of the current user. Defaults to :id Examples Assuming a typical User schema, with an :id primary key, and a typical Post schema, with a belongs_to association to a User: # lib/my_app_web/policies/post.ex defmodule MyAppWeb.Policies.Post do use Dictator.Policies.BelongsTo, for: MyApp.Post end If, however, the user has a uuid primary key and the post has an admin_id key instead of the typical uer_id, you should do the following: # lib/my_app_web/policies/post.ex defmodule MyAppWeb.Policies.Post do use Dictator.Policies.BelongsTo, for: MyApp.Post, owner_key: :uuid, foreign_key: :admin_id end","ref":"Dictator.Policies.BelongsTo.html","title":"Dictator.Policies.BelongsTo","type":"module"},{"doc":"Policy definition with resource loading. Requires Ecto. By default, Dictator does not fetch the resource being accessed. As an example, if the user is trying to GET /posts/1, no post is actually loaded, unless your policy uses Dictator.Policies.EctoSchema. By doing so, the third parameter in the can?/3 function includes the resource being accessed under the resource key. When use-ing Dictator.Policies.EctoSchema, the following options are available: for (required): schema to be loaded, e.g MyApp.Content.Post repo: Ecto.Repo to be used. Can also be provided through a configuration option. key: resource identifier. Defaults to :id. If you want your resource to be fetched through a different key (e.g uuid), use this option. Beware that, unless load_resource/1 is overriden, there needs to be a match between the key value and the parameter used. If you want to fetch your resource through a uuid attribute, there needs to be a corresponding &quot;uuid&quot; parameter. See Callback Overrides for alternatives to loading resources from the database. Configuration Options Options that you can place in your config/*.exs files. repo: Same as the :repo parameter in above section. The use option takes precedence, meaning you can place a global repo in your config and then override it in specific policies. Callback Overrides By default two callbacks are defined: c:can?/3 and load_resource/1. The former defaults to false, meaning you should always override it to correctly define your policy. The latter attempts to load the resource with a given :key (see the allowed parameters), assuming an equivalent string &quot;key&quot; is available in the HTTP parameters. This means that if you have a Post schema which is identified by an id, then you don&#39;t need to override, provided all routes refer to the post using an &quot;id&quot; parameter: # lib/my_app_web/router.ex resources &quot;/posts&quot;, PostController # lib/my_app_web/policies/post.ex defmodule MyAppWeb.Policies.Post do use Dictator.Policies.EctoSchema, for: MyApp.Post # override can?/3 here # ... end If, instead, you use uuid to identify posts, you should do the following: # lib/my_app_web/router.ex resources &quot;/posts&quot;, PostController, param: &quot;uuid&quot; # lib/my_app_web/policies/post.ex defmodule MyAppWeb.Policies.Post do use Dictator.Policies.EctoSchema, for: MyApp.Post, key: :uuid # override can?/3 here # ... end If, however, you use a mixture of both, you should override c:load_resource/3. This example assumes the primary key for your Post is uuid but the routes use id. # lib/my_app_web/router.ex resources &quot;/posts&quot;, PostController # lib/my_app_web/policies/post.ex defmodule MyAppWeb.Policies.Post do use Dictator.Policies.EctoSchema, for: MyApp.Post def load_resource(params) do MyApp.Repo.get_by(MyApp.Post, uuid: params[&quot;id&quot;]) end # override can?/3 here # ... end","ref":"Dictator.Policies.EctoSchema.html","title":"Dictator.Policies.EctoSchema","type":"behaviour"},{"doc":"Fetches the Ecto.Repo from the config. Intended for internal use.","ref":"Dictator.Policies.EctoSchema.html#default_repo/0","title":"Dictator.Policies.EctoSchema.default_repo/0","type":"function"},{"doc":"Overridable callback to load from the database the resource being accessed. Receives the HTTP parameters. Should return the resource or nil if none is found.","ref":"Dictator.Policies.EctoSchema.html#c:load_resource/1","title":"Dictator.Policies.EctoSchema.load_resource/1","type":"callback"},{"doc":"Policy behaviour definition. If your Policy requires the resource to be loaded (e.g. if you want a Post to be loaded when users are trying to GET &quot;/posts/1&quot;), use Dictator.Policies.EctoSchema instead. The most basic policies need only to implement the can?/3 callback.","ref":"Dictator.Policy.html","title":"Dictator.Policy","type":"behaviour"},{"doc":"Callback invoked to check if the current user is authorised to perform a given action. The most basic policies need only to implement this callback. This function receives the current user as the first parameter, the action to be performed as the second (e.g. :show) and finally a map containing the following keys: :resource - if it has been loaded. :params - the HTTP params. :opts - options passed to the plug.","ref":"Dictator.Policy.html#c:can?/3","title":"Dictator.Policy.can?/3","type":"callback"},{"doc":"Basic unauthorized handler to be called if none is provided. When a user is denied access to a resource, an unauthorized handler is called. This is the most basic definition. Simply returns 401 UNAUTHORIZED with the text &quot;you are not authorized to do that&quot;. No content type or any other header is provided.","ref":"Dictator.UnauthorizedHandlers.Default.html","title":"Dictator.UnauthorizedHandlers.Default","type":"module"},{"doc":"JSON API compatible unauthorized handler. Configure your app to use this handler instead of Dictator.UnauthorizedHandlers.Default by setting your config/*.exs to: config :dictator, unauthorized_handler: Dictator.UnauthorizedHandlers.JsonApi This handler sets the content-type header to application/json and sends an empty body with the 401 status as the response.","ref":"Dictator.UnauthorizedHandlers.JsonApi.html","title":"Dictator.UnauthorizedHandlers.JsonApi","type":"module"},{"doc":"Dictator Dictator is a plug-based authorization mechanism. Dictate what your users can access in fewer than 10 lines of code: # config/config.exs config :dictator, repo: Client.Repo # lib/client_web/controllers/thing_controller.ex defmodule ClientWeb.ThingController do use ClientWeb, :controller plug Dictator # ... end # lib/client_web/policies/thing.ex defmodule ClientWeb.Policies.Thing do alias Client.Context.Thing use Dictator.Policies.BelongsTo, for: Thing end And that&#39;s it! Just like that your users can edit, see and delete their own Things but not Things belonging to other users. Installation Usage Custom policies Dictator.Policies.EctoSchema Dictator.Policies.BelongsTo Plug Options Limitting the actions to be authorized Overriding the policy to be used Overriding the current user key Overriding the current user fetch strategy Configuration Options Setting a default repo Setting a default user key Setting the fetch strategy Setting the unauthorized handler Contributing Setup Other Projects About","ref":"readme.html","title":"Dictator","type":"extras"},{"doc":"First, you need to add :dictator to your list of dependencies on your mix.exs: def deps do [{:dictator, &quot;~&gt; 1.1&quot;}] end","ref":"readme.html#installation","title":"Dictator - Installation","type":"extras"},{"doc":"To authorize your users, just add in your controller: defmodule ClientWeb.ThingController do use ClientWeb, :controller plug Dictator # ... end Alternatively, you can also do it at the router level: defmodule ClientWeb.Router do pipeline :authorised do plug Dictator end end That plug will automatically look for a ClientWeb.Policies.Thing module, which should use Dictator.Policy. It is a simple module that should implement can?/3. It receives the current user, the action it is trying to perform and a map containing the conn.params, the resource being acccessed and any options passed when plug-ing Dictator. In lib/client_web/policies/thing.ex: defmodule ClientWeb.Policies.Thing do alias Client.Context.Thing use Dictator.Policies.EctoSchema, for: Thing # User can edit, update, delete and show their own things def can?(%User{id: user_id}, action, %{resource: %Thing{user_id: user_id}}) when action in [:edit, :update, :delete, :show], do: true # Any user can index, new and create things def can?(_, action, _) when action in [:index, :new, :create], do: true # Users can&#39;t do anything else (users editing, updating, deleting and showing) # on things they don&#39;t own def can?(_, _, _), do: false end This exact scenario is, in fact, so common that already comes bundled as Dictator.Policies.BelongsTo. This is equivalent to the previous definition: defmodule ClientWeb.Policies.Thing do alias Client.Context.Thing use Dictator.Policies.BelongsTo, for: Thing end IMPORTANT: Dictator assumes you have your current user in your conn.assigns. See our demo app for an example on integrating with guardian. Custom Policies Dictator comes bundled with three different types of policies: Dictator.Policies.EctoSchema: most common behaviour. When you use it, Dictator will try to call a load_resource/1 function by passing the HTTP params. This function is overridable, along with can?/3 Dictator.Policies.BelongsTo: abstraction on top of Dictator.Policies.EctoSchema, for the most common use case: when a user wants to read and write resources they own, but read access is provided to everyone else. This policy makes some assumptions regarding your implementation, all of those highly customisable. Dictator.Policy: most basic policy possible. use it if you don&#39;t want to load resources from the database (e.g to check if a user has an is_admin field set to true) Dictator.Policies.EctoSchema Most common behaviour. When you use it, Dictator will try to call a load_resource/1 function by passing the HTTP params. This allows you to access the resource in the third parameter of can/3?. The load_resource/1 function is overridable, along with can?/3. Take the following example: defmodule ClientWeb.Policies.Thing do alias Client.Context.Thing use Dictator.Policies.EctoSchema, for: Thing # User can edit, update, delete and show their own things def can?(%User{id: user_id}, action, %{resource: %Thing{user_id: user_id}}) when action in [:edit, :update, :delete, :show], do: true # Any user can index, new and create things def can?(_, action, _) when action in [:index, :new, :create], do: true # Users can&#39;t do anything else (users editing, updating, deleting and showing) # on things they don&#39;t own def can?(_, _, _), do: false end In the example above, Dictator takes care of loading the Thing resource through the HTTP params. However, you might want to customise the way the resource is loaded. To do that, you should override the load_resource/1 function. As an example: defmodule ClientWeb.Policies.Thing do alias Client.Context.Thing use Dictator.Policies.EctoSchema, for: Thing def load_resource(%{&quot;owner_id&quot; =&gt; owner_id, &quot;uuid&quot; =&gt; uuid}) do ClientWeb.Repo.get_by(Thing, owner_id: owner_id, uuid: uuid) end def can?(_, action, _) when action in [:index, :show, :new, :create], do: true def can?(%{id: owner_id}, action, %{resource: %Thing{owner_id: owner_id}}) when action in [:edit, :update, :delete], do: true def can?(_user, _action, _params), do: false end The following custom options are available: key: defaults to :id, primary key of the resource being accessed. repo: overrides the repo set by the config. Dictator.Policies.BelongsTo Policy definition commonly used in typical belongs_to associations. It is an abstraction on top of Dictator.Policies.EctoSchema. This policy assumes the users can read (:show, :index, :new, :create) any information but only write (:edit, :update, :delete) their own. As an example, in a typical Twitter-like application, a user has_many posts and a post belongs_to a user. You can define a policy to let users manage their own posts but read all others by doing the following: defmodule MyAppWeb.Policies.Post do alias MyApp.{Post, User} use Dictator.Policies.EctoSchema, for: Post def can?(_, action, _) when action in [:index, :show, :new, :create], do: true def can?(%User{id: id}, action, %{resource: %Post{user_id: id}}) when action in [:edit, :update, :delete], do: true def can?(_, _, _), do: false end This scenario is so common, it is abstracted completely through this module and you can simply use Dictator.Policies.BelongsTo, for: Post to make use of it. The following example is equivalent to the previous one: defmodule MyAppWeb.Policies.Post do use Dictator.Policies.BelongsTo, for: MyApp.Post end The assumptions made are that: your resource has a user_id foreign key (you can change this with the :foreign_key option) your user has an id primary key (you can change this with the :owner_id option) If your user has a uuid primary key and the post identifies the user through a :poster_id foreign key, you can do the following: defmodule MyAppWeb.Policies.Post do use Dictator.Policies.BelongsTo, for: MyApp.Post, foreign_key: :poster_id, owner_id: :uuid end The key and repo options supported by Dictator.Policies.EctoSchema are also supported by Dictator.Policies.BelongsTo. Plug Options plug Dictator supports 3 options: only/except: (optional) - actions subject to authorization. policy: (optional, infers the policy) - policy to be used resource_key: (optional, default: :current_user) - key to use in the conn.assigns to load the currently logged in resource. Limitting the actions to be authorized If you want to only limit authorization to a few actions you can use the :only or :except options when calling the plug in your controller: defmodule ClientWeb.ThingController do use ClientWeb, :controller plug Dictator, only: [:create, :update, :delete] # plug Dictator, except: [:show, :index, :new, :edit] # ... end In both cases, all other actions will not go through the authorization plug and the policy will only be enforced for the create,update and delete actions. Overriding the policy to be used By default, the plug will automatically infer the policy to be used. MyWebApp.UserController would mean a MyWebApp.Policies.User policy to use. However, by using the :policy option, that can be overriden defmodule ClientWeb.ThingController do use ClientWeb, :controller plug Dictator, policy: MyPolicy # ... end Overriding the current user key By default, the plug will automatically search for a current_user in the conn.assigns. You can change this behaviour by using the key option in the plug call. This will override the key option set in config.exs. defmodule ClientWeb.ThingController do use ClientWeb, :controller plug Dictator, key: :current_organization # ... end Overriding the current user fetch strategy By default, the plug will assume you want to search for the key set in the previous option in the conn.assigns. However, you may have it set in the session or want to use a custom strategy. You can change this behaviour by using the fetch_strategy option in the plug call. This will override the fetch_strategy option set in config.exs. There are two strategies available by default: Dictator.FetchStrategies.Assigns - fetches the given key from conn.assigns Dictator.FetchStrategies.Session - fetches the given key from the session defmodule ClientWeb.ThingController do use ClientWeb, :controller plug Dictator, fetch_strategy: Dictator.FetchStrategies.Session # ... end Configuration Options Dictator supports three options to be placed in config/config.exs: repo - default repo to be used by Dictator.Policies.EctoSchema. If not set, you need to define what repo to use in the policy through the :repo option. key (optional, defaults to :key) - key to be used to find the current user in conn.assigns. unauthorized_handler (optional, default: Dictator.UnauthorizedHandlers.Default) - module to call to handle unauthorisation errors. Setting a default repo Dictator.Policies.EctoSchema requires a repo to be set to load resource from. It is recommended that you set it in config/config.exs: config :dictator, repo: Client.Repo If not configured, it must be provided in each policy. The repo option when use-ing the policy takes precedence. So you can also set a custom repo for certain resources: defmodule ClientWeb.Policies.Thing do alias Client.Context.Thing alias Client.FunkyRepoForThings use Dictator.Policies.BelongsTo, for: Thing, repo: FunkyRepoForThings end Setting a default current user key By default, the plug will automatically search for a current_user in the conn.assigns. The default value is :current_user but this can be overriden by changing the config: config :dictator, key: :current_company The value set by the key option when plugging Dictator overrides this one. Setting the fetch strategy By default, the plug will assume you want to search for the key set in the previous option in the conn.assigns. However, you may have it set in the session or want to use a custom strategy. You can change this behaviour across the whole application by setting the fetch_strategy key in the config. There are two strategies available by default: Dictator.FetchStrategies.Assigns - fetches the given key from conn.assigns Dictator.FetchStrategies.Session - fetches the given key from the session config :dictator, fetch_strategy: Dictator.FetchStrategies.Session The value set by the key option when plugging Dictator overrides this one. Setting the unauthorized handler When a user does not have access to a given resource, an unauthorized handler is called. By default this is Dictator.UnauthorizedHandlers.Default which sends a simple 401 with the body set to &quot;you are not authorized to do that&quot;. You can also make use of the JSON API compatible Dictator.UnauthorizedHandlers.JsonApi or provide your own: config :dictator, unauthorized_handler: MyUnauthorizedHandler","ref":"readme.html#usage","title":"Dictator - Usage","type":"extras"},{"doc":"Feel free to contribute. If you found a bug, open an issue. You can also open a PR for bugs or new features. Your PRs will be reviewed and subject to our style guide and linters. All contributions must follow the Code of Conduct and Subvisual&#39;s guides.","ref":"readme.html#contributing","title":"Dictator - Contributing","type":"extras"},{"doc":"To clone and setup the repo: git clone git@github.com:subvisual/dictator.git cd dictator bin/setup And everything should automatically be installed for you. To run the development server: bin/server","ref":"readme.html#setup","title":"Dictator - Setup","type":"extras"},{"doc":"Not your cup of tea? 🍵 Here are some other Elixir alternatives we like: @schrockwell/bodyguard @jarednorman/canada @cpjk/canary @boydm/policy_wonk","ref":"readme.html#other-projects","title":"Dictator - Other projects","type":"extras"},{"doc":"Dictator is maintained by Subvisual.","ref":"readme.html#about","title":"Dictator - About","type":"extras"}]